#ifndef _QMOTION_H_
#define _QMOTION_H_

#include <QtGui>
#include "ui_qmotion.h"

#include <cv.h>
#include <highgui.h>

class QMotion : public QMainWindow, private Ui::QMainWindowBase
{
	Q_OBJECT

	public:
		QMotion(QWidget *parent = 0);
		~QMotion();
 
	public slots:
    void captureLoop();
		void fps_update();

	private slots:
		void about();

	private:
			static QImage Ipl2QImage(const IplImage *newImage);
			void  update_mhi(IplImage* img, IplImage* dst, int diff_threshold);
			CvCapture* capture_;
			QImage  qImage_;
			QImage  qMotion_;
			QTimer timer_;
			QTimer timer_fps_;
			IplImage* image_;
			IplImage* motion_;
			int counter_;
			int counter_last_;

			// ring image buffer
			IplImage **buf;
			int last;

			// temporary images
			IplImage *mhi; // MHI
			IplImage *orient; // orientation
			IplImage *mask; // valid orientation mask
			IplImage *segmask; // motion segmentation map
			CvMemStorage* storage; // temporary storage
};

#endif
